local outline, gr = {}, love.graphics
local alphaLimit, outLineColor,orID, osID, olID, orI,osI,olI
outline.image = function( file, color )
	alphaLimit	= .5
	outlineColor= color or { 1, 1, .4, 1 }
	orID		= love.image.newImageData( file..'.png' )
	local width		= orID:getWidth()
	local height	= orID:getHeight()
	osID		= love.image.newImageData( width, height )
	olID		= love.image.newImageData( width, height )
	for y = 1, height-2 do		-- scan original spritesheet
		for x = 1, width-2 do	-- only make changes to a copy
			local r, g, b, a = orID:getPixel( x, y )
			if a > alphaLimit then						-- sprite pixel
				osID:setPixel( x, y, r, g, b, a )	-- copy to 2nd image
				outline.edge( orID, x, y )				-- outline if edge pixel
				end
			end
		end
	orI	= gr.newImage( orID )		-- original
	osI	= gr.newImage( osID )		-- outlined sprites
	olI	= gr.newImage( olID )		-- outlines only
	return orI, osI, olI, osID, olID	-- return 3 images, 2 imagedatas
	end

outline.edge = function( id, x, y )	-- set neighbor point not on image
	for i = x-1, x+1 do
		_, _, _, a = id:getPixel( i, y-1 )
		if a <= alphaLimit then
			osID:setPixel( i, y-1, unpack(outlineColor) )
			olID:setPixel( i, y-1, unpack(outlineColor) )
			end
		_, _, _, a = id:getPixel( i, y+1 )
		if a <= alphaLimit then
			osID:setPixel( i, y+1, unpack(outlineColor) )
			olID:setPixel( i, y+1, unpack(outlineColor) )
			end
		end
	_, _, _, a = id:getPixel( x-1, y )
	if a <= alphaLimit then
		osID:setPixel( x-1, y, unpack(outlineColor) )
		olID:setPixel( x-1, y, unpack(outlineColor) )
		end
	_, _, _, a = id:getPixel( x+1, y )
	if a <= alphaLimit then
		osID:setPixel( x+1, y, unpack(outlineColor) )
		olID:setPixel( x+1, y, unpack(outlineColor) )
		end
	end

return outline